/* Problem URL: https://codeforces.com/edu/course/2/lesson/4/3/practice/contest/274545/problem/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }
    

    vl seg(n * 2);

    function<void(int, int, int, int, int, ll)> update = [&](int i, int l, int r, int tl, int tr, ll v) {
        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            seg[i] += v;
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, v);
    };

    auto query = [&](int i) {
        ll ans = 0;

        for (i += n; i > 0; i >>= 1) {
            ans += seg[i];
        }

        return ans;
    };

    while (m--) {
        int op;
        cin >> op;

        if (op == 1) {
            int l, r;
            ll v;
            cin >> l >> r >> v;

            update(1, 0, n - 1, l, r - 1, v);
            continue;
        }

        int i;
        cin >> i;

        cout << query(i) << '\n';
    }
}
